VSTGUI: CControl Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Classes | Public Member Functions | List of all members
CControl Class Referenceabstract

base class of all VSTGUI controls More...

`#include <ccontrol.h>`

Inheritance diagram for CControl:

## Classes
struct | Impl

## Public Member Functions
| CControl (const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
| CControl (const CControl &c)
Value Methods
virtual void | setValue (float val)
virtual float | getValue () const
virtual void | setValueNormalized (float val)
virtual float | getValueNormalized () const
virtual void | setMin (float val)
virtual float | getMin () const
virtual void | setMax (float val)
virtual float | getMax () const
float | getRange () const
virtual void | setOldValue (float val)
virtual float | getOldValue () const
virtual void | setDefaultValue (float val)
virtual float | getDefaultValue () const
virtual void | bounceValue ()
virtual void | valueChanged ()
| notifies listener and dependent objects
Editing Methods
virtual void | setTag (int32_t val)
virtual int32_t | getTag () const
virtual void | beginEdit ()
virtual void | endEdit ()
bool | isEditing () const
virtual IControlListener * | getListener () const
| get main listener
virtual void | setListener (IControlListener *l)
| set main listener
void | registerControlListener (IControlListener *listener)
| register a sub listener
void | unregisterControlListener (IControlListener *listener)
| unregister a sub listener
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
uint64_t | getRuntimeID () const
| get the unique runtime ID
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseDownEvent (MouseDownEvent &event)
| called when a mouse down event occurs
virtual void | onMouseMoveEvent (MouseMoveEvent &event)
| called when a mouse move event occurs
virtual void | onMouseUpEvent (MouseUpEvent &event)
| called when a mouse up event occurs
virtual void | onMouseCancelEvent (MouseCancelEvent &event)
| called when mouse tracking should be canceled
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | onMouseWheelEvent (MouseWheelEvent &event)
| called when a mouse wheel event occurs
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons)
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation
virtual SharedPointer< IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags
int32_t | getAutosizeFlags () const
| get autosize flags
virtual bool | sizeToFit ()
| resize view to optimal size
virtual void | looseFocus ()
| called if view should loose focus
virtual void | takeFocus ()
| called if view should take focus
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T>
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T>
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
virtual void | setTransparency (bool val)
| set views transparent state
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
virtual bool | removed (CView *parent)
| view is removed from parent view
virtual bool | attached (CView *parent)
| view is attached to a parent view
bool | isAttached () const
| is view attached to a parentView
void | setSubviewState (bool state)
bool | isSubview () const
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T>
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T>
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid
virtual void | invalid ()
| mark whole view as invalid
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexcept override=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
Public Member Functions inherited from ReferenceCounted< int32_t >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
| ReferenceCounted ()=default
| ReferenceCounted (const ReferenceCounted &)
virtual | ~ReferenceCounted () noexcept=default
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IFocusDrawing
virtual | ~IFocusDrawing () noexcept=default

## Misc
using | CheckDefaultValueEventFuncT = bool (*) (CControl*, MouseDownEvent&)
using | CheckDefaultValueFuncT = bool (*) (CControl*, CButtonState)
static CheckDefaultValueEventFuncT | CheckDefaultValueEventFunc
| Function to check if a mouse down event should reset the value to its default value for a control.
static int32_t | kZoomModifier = kShift
| zoom modifier key, per default is the shift key
static int32_t | kDefaultValueModifier = kControl
static CheckDefaultValueFuncT | CheckDefaultValueFunc
IControlListener * | listener
int32_t | tag
float | value
virtual void | setWheelInc (float val)
virtual float | getWheelInc () const
void | draw (CDrawContext *pContext) override=0
| called if the view should draw itself
bool | isDirty () const override
| check if view is dirty
void | setDirty (bool val=true) override
| set the view to dirty so that it is redrawn in the next idle.
bool | drawFocusOnTop () override
| draw focus before view will be drawn or afterwards
bool | getFocusPath (CGraphicsPath &outPath) override
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()
CBaseObject * | newCopy () const override=0
| ~CControl () noexcept override
static int32_t | mapVstKeyModifier (int32_t vstModifier)

## Additional Inherited Members
enum class | MouseListenerCall { MouseDown , MouseMoved , MouseUp , MouseCancel }
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle.
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0 , kTransparencyEnabled = 1 << 1 , kWantsFocus = 1 << 2 , kIsAttached = 1 << 3 , kVisible = 1 << 4 , kDirty = 1 << 5 , kWantsIdle = 1 << 6 , kIsSubview = 1 << 7 , kHasAlpha = 1 << 8 , kHasBackground = 1 << 9 , kHasDisabledBackground = 1 << 10 , kHasMouseableArea = 1 << 11 , kLastCViewFlag = 11 }
| ~CView () noexcept override
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Detailed Description

base class of all VSTGUI controls

This object manages the tag identification and the value of a control object.

## Member Typedef Documentation

## ◆ CheckDefaultValueEventFuncT

using CheckDefaultValueEventFuncT = bool (*) (CControl*, MouseDownEvent&)

## ◆ CheckDefaultValueFuncT

using CheckDefaultValueFuncT = bool (*) (CControl*, CButtonState)

## Constructor & Destructor Documentation

## ◆ CControl() [1/2]

CControl | ( | const CRect & | size,
|  | IControlListener * | listener = nullptr,
|  | int32_t | tag = 0,
|  | CBitmap * | pBackground = nullptr )

## ◆ CControl() [2/2]

CControl | ( | const CControl & | c | ) |

## ◆ ~CControl()

~CControl | ( |  | ) |
| overrideprotectednoexcept

## Member Function Documentation

## ◆ beginEdit()

void beginEdit | ( |  | ) |
| virtual

## ◆ bounceValue()

void bounceValue | ( |  | ) |
| virtual

## ◆ draw()

void draw | ( | CDrawContext * | pContext | ) |
| overridepure virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented from CView.

Implemented in CAnimationSplashScreen, CAnimKnob, CAutoAnimation, CCheckBox, CKickButton, CKnob, CListControl, CMovieBitmap, CMovieButton, COnOffButton, COptionMenu, CParamDisplay, CRockerSwitch, CScrollbar, CSearchTextEdit, CSegmentButton, CSlider, CSpecialDigit, CSplashScreen, CSwitchBase, CTextButton, CTextEdit, CTextLabel, CVuMeter, CXYPad, and CControlCreatorDummyControl.

## ◆ drawFocusOnTop()

bool drawFocusOnTop | ( |  | ) |
| overridevirtual

draw focus before view will be drawn or afterwards

Implements IFocusDrawing.

Reimplemented in CKnob, CListControl, CSegmentButton, and CTextButton.

## ◆ endEdit()

void endEdit | ( |  | ) |
| virtual

## ◆ getDefaultValue()

float getDefaultValue | ( | void |  | ) | const
| virtual

## ◆ getFocusPath()

bool getFocusPath | ( | CGraphicsPath & | outPath | ) |
| overridevirtual

the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()

Implements IFocusDrawing.

Reimplemented in CKnob, CListControl, CParamDisplay, CSegmentButton, and CTextButton.

## ◆ getListener()

virtual IControlListener * getListener | ( |  | ) | const
| inlinevirtual

get main listener

## ◆ getMax()

float getMax | ( |  | ) | const
| virtual

Reimplemented in COptionMenu.

## ◆ getMin()

float getMin | ( |  | ) | const
| virtual

Reimplemented in COptionMenu.

## ◆ getOldValue()

float getOldValue | ( | void |  | ) | const
| virtual

## ◆ getRange()

float getRange | ( |  | ) | const
| inline

## ◆ getTag()

virtual int32_t getTag | ( |  | ) | const
| inlinevirtual

## ◆ getValue()

virtual float getValue | ( |  | ) | const
| inlinevirtual

## ◆ getValueNormalized()

float getValueNormalized | ( |  | ) | const
| virtual

## ◆ getWheelInc()

float getWheelInc | ( |  | ) | const
| virtual

## ◆ isDirty()

bool isDirty | ( |  | ) | const
| overridevirtual

check if view is dirty

Reimplemented from CView.

## ◆ isEditing()

bool isEditing | ( |  | ) | const

## ◆ mapVstKeyModifier()

int32_t mapVstKeyModifier | ( | int32_t | vstModifier | ) |
| staticprotected

## ◆ newCopy()

CBaseObject * newCopy | ( |  | ) | const
| overridepure virtual

Implemented in CAnimKnob, CAutoAnimation, CCheckBox, CExternalControl, CHorizontalSwitch, CKickButton, CKnob, CKnobBase, CListControl, CMovieBitmap, CMovieButton, COnOffButton, COptionMenu, CParamDisplay, CRockerSwitch, CScrollbar, CSegmentButton, CSlider, CSpecialDigit, CSplashScreen, CTextButton, CTextEdit, CTextLabel, CVerticalSwitch, CVuMeter, and CControlCreatorDummyControl.

## ◆ registerControlListener()

void registerControlListener | ( | IControlListener * | listener | ) |

register a sub listener

## ◆ setDefaultValue()

void setDefaultValue | ( | float | val | ) |
| virtual

Reimplemented in CXYPad.

## ◆ setDirty()

void setDirty | ( | bool | val = true | ) |
| overridevirtual

set the view to dirty so that it is redrawn in the next idle.

Thread Safe !

Reimplemented from CView.

Reimplemented in CVuMeter.

## ◆ setListener()

virtual void setListener | ( | IControlListener * | l | ) |
| inlinevirtual

set main listener

## ◆ setMax()

void setMax | ( | float | val | ) |
| virtual

Reimplemented in CKnobBase, CListControl, COptionMenu, and CXYPad.

## ◆ setMin()

void setMin | ( | float | val | ) |
| virtual

Reimplemented in CKnobBase, CListControl, COptionMenu, and CXYPad.

## ◆ setOldValue()

void setOldValue | ( | float | val | ) |
| virtual

## ◆ setTag()

void setTag | ( | int32_t | val | ) |
| virtual

## ◆ setValue()

void setValue | ( | float | val | ) |
| virtual

Reimplemented in CExternalControl, CMultiLineTextLabel, COptionMenu, and CTextEdit.

## ◆ setValueNormalized()

void setValueNormalized | ( | float | val | ) |
| virtual

## ◆ setWheelInc()

void setWheelInc | ( | float | val | ) |
| virtual

## ◆ unregisterControlListener()

void unregisterControlListener | ( | IControlListener * | listener | ) |

unregister a sub listener

## ◆ valueChanged()

void valueChanged | ( |  | ) |
| virtual

notifies listener and dependent objects

Reimplemented in CSegmentButton, CSplashScreen, CTextEdit, and CTextLabel.

## Member Data Documentation

## ◆ CheckDefaultValueEventFunc

CControl::CheckDefaultValueEventFuncT CheckDefaultValueEventFunc
| static

Initial value:
=
[] (CControl* c, MouseDownEvent& event) {
if (event.buttonState.isLeft ())
{
return CheckDefaultValueFunc (c, buttonStateFromMouseEvent (event));
}
return false;
}
VSTGUI::CControl::CControl
CControl(const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
Definition ccontrol.cpp:62
VSTGUI::CControl::CheckDefaultValueFunc
static CheckDefaultValueFuncT CheckDefaultValueFunc
Definition ccontrol.h:115
VSTGUI::buttonStateFromMouseEvent
CButtonState buttonStateFromMouseEvent(const MouseEvent &event)
convert from new MouseEvent to old CButtonState
Definition events.cpp:34
VSTGUI::MouseDownEvent
MouseDownEvent.
Definition events.h:312

Function to check if a mouse down event should reset the value to its default value for a control.

Per default this checks for a left mouse down button and the control modifier key.

## ◆ CheckDefaultValueFunc

CControl::CheckDefaultValueFuncT CheckDefaultValueFunc
| static

Initial value:
= [] (CControl*,
CButtonState button) {
return (button.isLeftButton () && button.getModifierState () == kDefaultValueModifier);
}
VSTGUI::CControl::kDefaultValueModifier
static int32_t kDefaultValueModifier
Definition ccontrol.h:108
VSTGUI::CButtonState
Button and Modifier state.
Definition cbuttonstate.h:47

Deprecated
  Function to check if the button state is the state to set the control value to its default value. The default implementation uses the kDefaultValueModifier (see above). Use this to change this to double click per example. But consider to change this to the same behaviour as the host you are running in for best user experience.

## ◆ kDefaultValueModifier

int32_t kDefaultValueModifier = kControl
| inlinestatic

Deprecated
  default value modifier key, per default is the control key

## ◆ kZoomModifier

int32_t kZoomModifier = kShift
| inlinestatic

zoom modifier key, per default is the shift key

## ◆ listener

IControlListener* listener
| protected

## ◆ tag

int32_t tag
| protected

## ◆ value

float value
| protected

The documentation for this class was generated from the following files:

- ccontrol.h
- ccontrol.cpp